<?php
/**
 * MapLab Information page
 *
 * @project     MapLab
 * @revision    $Id: info.php,v 1.9.2.1 2003/09/18 02:16:21 pspencer Exp $
 * @purpose     This is the information page.
 * @author      William A. Bronsema C.E.T. (bronsema@dmsolutions.ca)
 * @copyright
 * <b>Copyright (c) 2001, DM Solutions Group Inc.</b>
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

/*****************************************************************************
 * $Log: info.php,v $
 * Revision 1.9.2.1  2003/09/18 02:16:21  pspencer
 * make sure to load php_gd2 if php_gd not available.
 *
 * Revision 1.9  2002/09/18 19:44:59  sacha
 * Make sure all module are loaded.
 *
 * Revision 1.8  2002/09/06 15:34:10  bronsema
 * Checks for and loads GD module.
 *
 * Revision 1.6  2002/08/12 12:57:50  sacha
 * Moved all common lib into htdocs. Not yet completed with Mapbrowser and gmapfactory.
 *
 * Revision 1.5  2002/07/17 14:42:53  sacha
 * When php mapscript module is loaded in php.ini, set the bMapscript to
 * true.
 *
 * Revision 1.4  2002/06/30 17:42:34  pspencer
 * remove notice about register_globals
 *
 * Revision 1.3  2002/06/13 22:01:59  jmckenna
 * - fix by Paul (JM)
 *
 * Revision 1.2  2002/06/13 17:59:07  pspencer
 * added additional checks for php configuration
 *
 * Revision 1.1  2002/06/09 04:11:05  bronsema
 * Moved info to new dialog
 *
 *****************************************************************************/

// ensure that the gd module is loaded
if (PHP_OS == "WINNT" || PHP_OS == "WIN32")
{
    if (!extension_loaded("gd")) 
        if(!@dl("php_gd.dll"))
            dl("php_gd2.dll");
    if (!extension_loaded("dbase")) dl("php_dbase.dll");
}
else
{
    if (!extension_loaded("gd"))
        if(!@dl("php_gd.so"))
            dl("php_gd2.so");
    if (!extension_loaded("dbase")) dl("dbase.so");
}
 
// define path to the common utils
define( "COMMON", "./common/" );
include_once("./common/appcontext/appcontext.php");

/* ============================================================================
 * MapLab Info
 * ========================================================================= */
// get info from xml
$oAppContext = new AppContext("../config/maplab.xml");

// get list of installed packages
$gaszInstalledPkgs = explode("|", $oAppContext->
                                        getContextValue("installed_packages"));

// Convert to lower case
$nCount = count( $gaszInstalledPkgs );
for ( $i=0; $i<$nCount; $i++ )
{
    $gaszInstalledPkgs[$i] = trim( strtolower( $gaszInstalledPkgs[$i] ) );
}

// get the version
$gszVersion = $oAppContext->getContextValue("version");

//get the build date
$gszBuildDate = $oAppContext->getContextValue("build_date");

/* ============================================================================
 * Mapscript Info
 * ========================================================================= */
// ensure mapscript module is loaded
if (!extension_loaded("MapScript"))
    $bMapscriptValid = @dl($oAppContext->getContextValue("mapscript_module"));
else
    $bMapscriptValid = true;

// initialize array
$gaMSImageTypes = array();

if ( $bMapscriptValid )
{
    // check each
    if (strpos( ms_GetVersion(), "OUTPUT=GIF") > 0 )
        array_push( $gaMSImageTypes, MS_GIF );
    if (strpos( ms_GetVersion(), "OUTPUT=PNG") > 0 )
        array_push( $gaMSImageTypes, MS_PNG );
    if (strpos( ms_GetVersion(), "OUTPUT=JPEG") > 0 )
        array_push( $gaMSImageTypes, MS_JPEG );
    if (strpos( ms_GetVersion(), "OUTPUT=WBMP") > 0 )
        array_push( $gaMSImageTypes, MS_WBMP );
}

/* ============================================================================
 * Php Image Types
 * ========================================================================= */
// initialize array
$gaPhpImageTypes = array();

// check each
if ( ImageTypes() & IMG_GIF )
   array_push( $gaPhpImageTypes, "GIF" );
if ( ImageTypes() & IMG_PNG )
   array_push( $gaPhpImageTypes, "PNG" );
if ( ImageTypes() & IMG_JPG )
   array_push( $gaPhpImageTypes, "JPEG" );
if ( ImageTypes() & IMG_WBMP )
   array_push( $gaPhpImageTypes, "WBMP" );

/* ============================================================================
 * Php Configuration File Settings
 *
 * the array has the configuration value as the key and the value is an array
 * of three elements.  The first is the required value.  The second is
 * read from PHP using ini_get.  The third is the message to display about the
 * setting.  The same structure is used for both Mandatory and Recommended
 * settings.
 * ========================================================================= */
$gaszMandatorySettings = array(
    "enable_dl" => array( "1", "1", "this value must be set to on or 1 in php.ini" ),
                              );

foreach( array_keys($gaszMandatorySettings) as $szIniKey)
{
    $gaszMandatorySettings[$szIniKey][1] = ini_get( $szIniKey );
}

$gaszRecommendedSettings = array(
    "error_reporting" => array( "0", "0", "you should disable E_NOTICE warnings<br>(i.e.set error_reporting = E_ALL & ~E_NOTICE in php.ini)" ),
    "session_save_path" => array( "0", "0", "" )
                                );

foreach( array_keys($gaszRecommendedSettings) as $szIniKey )
{
    if ($szIniKey == "error_reporting")
    {
        $anErrorLevels = array( "E_ERROR" => 1,
                                "E_WARNING" => 2,
                                "E_PARSE" => 4,
                                "E_NOTICE" => 8,
                                "E_CORE_ERROR" => 16,
                                "E_CORE_WARNING" => 32,
                                "E_COMPILE_ERROR" => 64,
                                "E_COMPILE_WARNING" => 128,
                                "E_USER_ERROR" => 256,
                                "E_USER_WARNING" => 512,
                                "E_USER_NOTICE" => 1024
                              );
        //calculate the output string for the current value
        //and set it in index 1
        $nErrorLevel = error_reporting();
        $szValue = "<font size=1>";
        $szSep = "";
        foreach( $anErrorLevels as $szLevel => $nLevel )
        {
            if ($nErrorLevel & $nLevel)
            {
                $szValue .= $szSep.$szLevel;
                $szSep = "<BR>";
            }
        }
        $szValue .= "</font>";
        $gaszRecommendedSettings[$szIniKey][1] = $szValue;

        //calculate the output string if E_NOTICE is not included
        //and set it as the required value (index 0)
        $nErrorLevel = error_reporting() & ~E_NOTICE;
        $szValue = "<font size=1>";
        $szSep = "";
        foreach( $anErrorLevels as $szLevel => $nLevel )
        {
            if ($nErrorLevel & $nLevel)
            {
                $szValue .= $szSep.$szLevel;
                $szSep = "<BR>";
            }
        }
        $szValue .= "</font>";
        $gaszRecommendedSettings[$szIniKey][0] = $szValue;
    }
    elseif ( $szIniKey == "session_save_path" )
    {
        // get the session save path
        $szTmpSSPath = trim( session_save_path() );
        $gaszRecommendedSettings[$szIniKey][1] = "";
        $n15Count = 0;
        
        // loop through and break every 15 chars
        for ( $i = 0; $i < strlen( $szTmpSSPath ); $i++ )
        {
            // increment counter
            $n15Count++;
            
            // add next character
            $gaszRecommendedSettings[$szIniKey][1] .= 
                                                substr( $szTmpSSPath, $i, 1 );
            
            // if the count is 15 then add break
            if ( $n15Count == 15 )
            {
                $gaszRecommendedSettings[$szIniKey][1] .= "<br>";
                $n15Count = 0; 
            }
        }
        
        // check if valid
        if ( $gaszRecommendedSettings[$szIniKey][1] != "" )
        {
            $gaszRecommendedSettings[$szIniKey][0] = 
                                        $gaszRecommendedSettings[$szIniKey][1];
        }
    }
    else
    {
        $gaszRecommendedSettings[$szIniKey][1] = ini_get( $szIniKey );
    }
}



/* ============================================================================
 * Php Required Modules (in enable_dl is off)
 * ========================================================================= */
$gaszModuleNames = array( "MapScript" => "",
                          "dbase" => "",
                          "gd" => "" );
foreach( array_keys($gaszModuleNames) as $szModuleName )
{
    $gaszModuleNames[$szModuleName] = extension_loaded( $szModuleName );
}
?>
